<template>
	<view class="pages-map-task">
		<view class="task-div" v-if="selectedType !='set'">
			<view class="header">
				<view class="item">
					<view class="title">{{accumulated_duration}}<text class="text">min</text></view>
					<view class="text">累计时长</view>
				</view>
				<view class="item">
					<view class="title">{{accumulated_mileage}}<text class="text">m</text></view>
					<view class="text">累计里程</view>
				</view>
				<view class="item">
					<view class="title">{{cumulative_number}}</view>
					<view class="text">累计次数</view>
				</view>
			</view>
			<view class="list">
				<view class="task-header" v-if="fixedList.length > 0">固定任务</view>
				<view class="task-list" v-if="fixedList.length > 0">
					<TaskLogItemView class="item" v-for="(item,index) in fixedList" :key="index" :taskData="item"
						@click-item="clickTask">

					</TaskLogItemView>
				</view>
				<view class="task-header" v-if="tempList.length > 0">临时任务</view>
				<view class="task-list" v-if="tempList.length > 0">
					<TaskLogItemView class="item" v-for="(item,index) in tempList" :key="index" :taskData="item"
						@click-item="clickTask">

					</TaskLogItemView>
				</view>
			</view>
		</view>
		<view class="task-set" v-else>
			<view class="list-header" v-if="fixedSetList.length > 0">固定任务</view>
			<view class="set-list">
				<TaskItemView class="list-item" v-for="(item,index) in fixedSetList" :key="index" :taskData="item"
					:deleteX="deleteX[0][index]" @click-item="clickSetTask" @click-delete="clickDelSetTask"
					@touchstart="touchStart($event,0, index)" @touchmove="touchMove($event,0, index)"
					@touchend="touchEnd($event, 0,index)">

				</TaskItemView>
			</view>
			<view class="list-header" v-if="tempSetList.length > 0">临时任务</view>
			<view class="set-list">
				<TaskItemView class="list-item" v-for="(item,index) in tempSetList" :key="index" :taskData="item"
					:deleteX="deleteX[1][index]" @click-item="clickSetTask" @click-delete="clickDelSetTask"
					@touchstart="touchStart($event, 1,index)" @touchmove="touchMove($event,1, index)"
					@touchend="touchEnd($event, 1,index)">

				</TaskItemView>
			</view>
		</view>
		<view class="bottom">
			<view class="button" :class="selectedType =='set'?'':'selected'" @click="clickTaskList">
				<uni-icons class="icon" :color="selectedType !='set'?'#1ABC9C':'#ccc'" type="bars"
					size="36"></uni-icons>任务记录
			</view>
			<view class="button" :color="selectedType =='set'?'#1ABC9C':'#ccc'"
				:class="selectedType =='set'?'selected':''" @click="clickTaskSet">
				<uni-icons class="icon" :color="selectedType =='set'?'#1ABC9C':'#ccc'" type="gear-filled"
					size="36"></uni-icons>任务设置
			</view>
		</view>
	</view>
</template>

<script>
	import {
		showToast,
		showModal
	} from "@/comm/utils.js"
	import TaskLogItemView from "./infos/task-log-item.vue"
	import TaskItemView from "./infos/task-item.vue"
	export default {
		name: "PagesMapTask",
		components: {
			TaskLogItemView,
			TaskItemView
		},
		data() {
			return {
				selectedType: "list",
				accumulated_duration: 167991,
				accumulated_mileage: 7532556,
				cumulative_number: 6000,
				taskList: [{
						name: "1号站点到2号站点",
						date: "5-18",
						accumulated_duration: 5693,
						accumulated_mileage: 6421,
						cumulative_number: 55,
						type: 0,
					}, {
						name: "2号站点到1号站点",
						date: "5-08",
						accumulated_duration: 888,
						accumulated_mileage: 642,
						cumulative_number: 31,
						type: 0,
					}, {
						name: "1号站点到2号站点",
						date: "4-28",
						accumulated_duration: 998,
						accumulated_mileage: 2421,
						cumulative_number: 85,
						type: 0,
					}, {
						name: "2号站点到1号站点",
						date: "4-28",
						accumulated_duration: 688,
						accumulated_mileage: 1421,
						cumulative_number: 65,
						type: 0,
					},
					{
						name: "1号站点到2号站点",
						date: "5-18",
						accumulated_duration: 5693,
						accumulated_mileage: 6421,
						cumulative_number: 55,
						type: 1,
					}, {
						name: "2号站点到1号站点",
						date: "5-08",
						accumulated_duration: 888,
						accumulated_mileage: 642,
						cumulative_number: 31,
						type: 1,
					}, {
						name: "1号站点到2号站点",
						date: "4-28",
						accumulated_duration: 998,
						accumulated_mileage: 2421,
						cumulative_number: 85,
						type: 1,
					}, {
						name: "2号站点到1号站点",
						date: "4-28",
						accumulated_duration: 688,
						accumulated_mileage: 1421,
						cumulative_number: 65,
						type: 1,
					}
				],
				setList: [{
					id: "1",
					name: "2号站点到1号站点",
					status: 1,
					type: 0,
					attribute: 0,
					start_point: "2号站点",
					end_point: "1号站点",
					start_time: "15:00",
					end_time: "21:00",
					button_no: "1",
					button_color: "#aa00ff"
				}, {
					id: "2",
					name: "1号站点到2号站点",
					status: 0,
					type: 0,
					attribute: 0,
					start_point: "2号站点",
					end_point: "1号站点",
					start_time: "15:00",
					end_time: "21:00",
					button_no: "2",
					button_color: "#55aaff"
				}, {
					id: "3",
					name: "2号站点到1号站点",
					status: 0,
					type: 1,
					attribute: 0,
					start_point: "2号站点",
					end_point: "1号站点",
					start_time: "15:00",
					end_time: "21:00",
					button_no: "3",
					button_color: "#ffaa7f"

				}],

				startX: 0, // 触摸起始点
				deleteX: [
					[],
					[]
				], // 每个项目的偏移量
			}
		},
		computed: {
			fixedList() {
				return this.taskList.filter((a) => a.type != 1)
			},
			tempList() {
				return this.taskList.filter((a) => a.type == 1)
			},
			fixedSetList() {
				return this.setList.filter((a) => a.type != 1)
			},
			tempSetList() {
				return this.setList.filter((a) => a.type == 1)
			},
		},

		methods: {
			setData(obj) {
				let that = this;
				let keys = [];
				let val, data;

				Object.keys(obj).forEach(function(key) {
					keys = key.split(".");
					val = obj[key];
					data = that.$data;
					keys.forEach(function(key2, index) {
						if (index + 1 == keys.length) {
							that.$set(data, key2, val);
						} else {
							if (!data[key2]) {
								that.$set(data, key2, {});
							}
						}
						data = data[key2];
					});
				});
			},
			clickTask(item) {
				uni.navigateTo({
					url: "/pages/task/index"
				})
			},
			clickSetTask(item) {
				uni.navigateTo({
					url: `/pages/task/set?param=${JSON.stringify(item)}`
				})
			},
			clickDelSetTask(item) {
				showModal("确认删除任务设置", "警告").then((res) => {
					if (res) {
						const list = this.setList
						const index = list.findIndex((a) => {
							a.id == item.id
						})
						if (index < 0)
							return
						list.splice(index, 1)
						this.setData({
							setList: list
						})
					}
				})
			},

			clickTaskList() {
				this.selectedType = "list"
			},
			clickTaskSet() {
				this.selectedType = "set"
			},
			touchStart(event, root, index) {
				this.startX = event.touches[0].pageX;
				const old = this.deleteX[root][index]
				if (old) {
					this.deleteX = [
						[],
						[]
					]
					this.deleteX[root][index] = old; // 重置偏移量
				} else
				{
					this.deleteX = [
						[],
						[]
					]
					this.deleteX[root][index] = 0; // 重置偏移量
				}
				
			},
			touchMove(event, root, index) {
				const moveX = event.touches[0].pageX - this.startX;
				if (moveX < 0) {
					this.deleteX[root][index] = moveX; // 左滑时更新偏移量
				}
				else if (moveX > 0) {
					this.deleteX[root][index] =0
				}
			},
			touchEnd(event, root, index) {
				if (this.deleteX[root][index] < -50) { // 如果滑动距离超过一定阈值，显示删除按钮
					this.deleteX[root][index] = -80; // 设置固定偏移量
				} else {
					this.deleteX[root][index] = 0; // 否则恢复原位
				}
			},


		}
	}
</script>

<style lang="scss">
	.pages-map-task {
		display: flex;
		width: 750rpx;
		height: 100vh;
		flex-direction: column;

		.task-div {
			display: flex;
			width: 100%;
			flex: 1;
			flex-direction: column;
			overflow: auto;
		}

		.header {
			width: 100%;
			padding: 10px;
			height: 30px;
			display: flex;
			flex-direction: row;

			.item {
				padding: 0 10px;
				display: flex;
				width: 100%;
				flex-direction: column;
				flex: 1;

				.title {
					font-size: 20px;
					font-weight: 700;
				}

				.text {
					font-size: 14px;
					color: #888;
				}
			}
		}

		.list {
			width: calc(100% - 40px);
			margin: 10px;
			padding: 0 10px;
			display: flex;
			flex-direction: column;
			flex: 1;
			overflow: auto;

		}

		.task-header {
			width: 100%;
			padding: 10px;
			font-size: 15px;
		}

		.task-list {
			border: 1px solid #ccc;
			border-radius: 5px;
			padding: 0 10px;

			.item {

				border-bottom: 1px solid #ddd;
			}
		}

		.task-set {
			display: flex;
			width: calc(100% - 20px);
			padding: 0 10px;
			flex: 1;
			flex-direction: column;
			overflow-y: auto;
			overflow-x: hidden;

			.list-header {
				margin: 10px;
				border-bottom: 1px solid #ddd;
			}

			.set-list {
				// border: 1px solid #ccc;
				border-radius: 10px;

				background-color: #fff;

				.list-item {

					border-bottom: 1px solid #ddd;
				}
			}

		}

		.bottom {
			display: flex;
			justify-content: center;
			align-items: center;
			flex-direction: row;
			font-size: 14px !important;
			color: #ccc;

			.button {
				margin: 10px 20px;
				width: 100px !important;
				height: 100px !important;
				border: 0;
				display: flex;
				flex-direction: column;
				background-color: #00000000;

				.icon {
					margin: 10px !important;
					width: 28px;
					height: 28px;

				}
			}

			.selected {
				color: #1ABC9C;

				.icon {
					margin: 10px !important;
					width: 28px;
					height: 28px;

				}
			}


		}

	}
</style>